"""
Licensed to the Apache Software Foundation (ASF) under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  The ASF licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing,
software distributed under the License is distributed on an
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, either express or implied.  See the License for the
specific language governing permissions and limitations
under the License.
"""
# -*- coding: utf-8 -*-

from models import crud

def create_index(cluster_obj, namespace, set_name, index_name, bin_name, bin_type, user=None, password=None):

    crud_obj = crud.Crud(cluster_obj)
    if user is not None:
        response = crud_obj.create_index(cluster_obj, namespace, set_name, index_name, bin_name, bin_type, user=user, password=password)
    else:
        response = crud_obj.create_index(cluster_obj, namespace, set_name, index_name, bin_name, bin_type)
    return response


def drop_index(cluster_obj, namespace, index_name, user=None, password=None):

    crud_obj = crud.Crud(cluster_obj)
    if user is not None:
        response = crud_obj.drop_index(cluster_obj, namespace, index_name, user=user, password=password)
    else:
        response = crud_obj.drop_index(cluster_obj, namespace, index_name)
    return response


def add_udf(cluster_obj, file_name, file_contents, udf_type, user=None, password=None):

    crud_obj = crud.Crud(cluster_obj)
    if user is not None:
        response = crud_obj.add_udf(cluster_obj, file_name, file_contents, udf_type, user=user, password=password)
    else:
        response = crud_obj.add_udf(cluster_obj, file_name, file_contents, udf_type)
    return response


def drop_udf(cluster_obj, file_name, user=None, password=None):

    crud_obj = crud.Crud(cluster_obj)
    if user is not None:
        response = crud_obj.drop_udf(cluster_obj, file_name, user=user, password=password)
    else:
        response = crud_obj.drop_udf(cluster_obj, file_name)
    return response